<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Christian Philipp <cp@typo3macher.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
include_once(PATH_site.'typo3/sysext/cms/tslib/class.tslib_content.php');

/**
 * Plugin 'Cumulus Tagcloud' for the 't3m_cumulus_tagcloud' extension.
 *
 * @author	Christian Philipp <cp@typo3macher.de>
 * @package	TYPO3
 * @subpackage	tx_t3mcumulustagcloud
 */
class tx_t3mcumulustagcloud_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_t3mcumulustagcloud_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_t3mcumulustagcloud_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 't3m_cumulus_tagcloud';	// The extension key.
	var $pi_checkCHash = true;
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	 
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		
		//get extension-path
		$url2ext = t3lib_extMgm::siteRelPath("t3m_cumulus_tagcloud");
		//get Flexform XML from pi_flexform
		$this->pi_initPIFlexForm();
		
		//get the values
		$input_pid = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'inputPID', 'sDEF');
		$input_width = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'inputWidth', 'sDEF');
		$input_height = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'inputHeight', 'sDEF');
		$input_bgcolor = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'inputBgColor', 'sDEF');
		$checkbox_transparent = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'checkboxTransparent', 'sDEF');
		$input_textcolor = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'inputTextColor', 'sDEF');
		$input_rotationspeed = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'inputRotationSpeed', 'sDEF');
		$checkbox_intervals = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'checkboxIntervals', 'sDEF');
				
		//get current pid
		$pid = $GLOBALS["TSFE"]->id;
		
		//get all Tags from db, which are for current page
		$linksOnCurrentPage = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
		
			'*',
		
			'tx_t3mcumulustagcloud_data',
					
			'hidden=0 AND deleted = 0 AND pid='.$pid,
			
			'',
		
			'link_name'

		);
		
		$link_rows = array();

		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($linksOnCurrentPage)){

			$link_rows[] = $row;

		}
		
		//if empty, get default tags
		if (empty($link_rows)){
		
			$links = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			
				'*',
			
				'tx_t3mcumulustagcloud_data',
					
				'pid = '.$input_pid.' AND hidden = 0 AND deleted = 0',
				
				'',
			
				'link_name'
	
			);		
			
			$link_rows = array();
	
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($links)){

				$link_rows[] = $row;
	
			}
		}

		$content='
			
			<script type="text/javascript" src="'.$url2ext.'pi1/swfobject.js"></script>
			
			<div id="wpcumuluswidgetcontent">
				<p style="display:none">';

		$cObj=t3lib_div::makeInstance('tslib_cObj');
		
		//now put together the html-code
		$link_code ="";
		for ($c=0; $c<sizeof($link_rows); $c++){
			
			$aTagParam = 'class="tag-link-'.$c.'" title="'.$link_rows[$c]['link_name'].'" rel="tag" style="font-size: '.$link_rows[$c]['link_size'].'pt;"';
			$link_code .= $cObj->typoLink($link_rows[$c]['link_name'],array('parameter' => $link_rows[$c]['link_url'], 'ATagParams' => $aTagParam));
		}
			
		//encode it for flash-file, adding the <tags> tag. I used a namespace, even if it is useless a this point 
    //Thanks Julien! :)
		$link_code_html = urlencode("<fla:tags xmlns:fla=\"http://www.roytanck.com/2009/03/11/how-to-use-wp-cumulus-shortcodes/\">".$link_code."</fla:tags>");
		
		$content .=$link_code;	
		
		
		$content .='</p>
				<p>TYPO3 Cumulus Flash tag cloud by <a href="http://www.typo3macher.de">TYPO3Macher</a> (based on WP Cumulus Flash tag cloud by <a href="http://www.roytanck.com">Roy Tanck</a>) requires Flash Player 9 or better.</p>
			</div>';
		
		if ($input_width == ''){
			$input_width = '350';
		}
		if ($input_height == ''){
			$input_height = '350';
		}
		if ($input_bgcolor == ''){
			$input_bgcolor = 'ffffff';
		}
		//call flash-file via js
		$content .='
			<script type="text/javascript">var rnumber = Math.floor(Math.random()*9999999);var widget_so = new SWFObject("'.$url2ext.'pi1/tagcloud.swf?r="+rnumber, "tagcloudflash", "'.$input_width.'", "'.$input_height.'", "9", "#'.$input_bgcolor.'");';
			
		//add this parameter to make the background transparent
		if ($checkbox_transparent == '1'){
			$content .='widget_so.addParam("wmode", "transparent");';
		}

		$content .='widget_so.addParam("allowScriptAccess", "always");';
		
		//change textcolor here
		if ($input_textcolor == ''){
			$input_textcolor = '000000';
		}
		$content .='widget_so.addVariable("tcolor", "0x'.$input_textcolor.'");';
		
		//change rotation-speed here - 100 is default
		if ($input_rotationspeed == ''){
			$input_rotationspeed = '100';
		}
		$content .='widget_so.addVariable("tspeed", "'.$input_rotationspeed.'");';
		
		//if true, tags are placed at equal intervals, if false, tags are placed randomly
		if ($checkbox_intervals == '1'){
			$content .='widget_so.addVariable("distr", "true");';
		}
		else{
			$content .='widget_so.addVariable("distr", "false");';
		}
		$content .='widget_so.addVariable("mode", "tags");';
		$content .='widget_so.addVariable("tagcloud", "';
		$content .= $link_code_html;
		$content .= '"); widget_so.write("wpcumuluswidgetcontent");</script>';
		return '<!--TYPO3SEARCH_end-->'.$this->pi_wrapInBaseClass($content).'<!--TYPO3SEARCH_begin-->'  ;
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3m_cumulus_tagcloud/pi1/class.tx_t3mcumulustagcloud_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3m_cumulus_tagcloud/pi1/class.tx_t3mcumulustagcloud_pi1.php']);
}

?>